#!/usr/bin/python
import re
import sys
import os
from decimal import Decimal, getcontext

if (len(sys.argv) < 3):
  print "Error: pass i/d/a sortdim"
  sys.exit(-1)

interpol = (sys.argv[1] == 'i')
all_aforms = (sys.argv[1] == 'a')
sortdim = int(sys.argv[2])

def floatify (sd):
  return float(sd.replace('~','-'))

now = False or all_aforms
while 1:
  try:
    line = sys.stdin.readline()
  except KeyboardInterrupt:
    break
  if not line:
    break
  if line.strip() == '':
    continue
  if (not all_aforms and (interpol and line.startswith('= interpolated step:')) or (not interpol and line.startswith('= discrete step:'))):
    now = True
    continue
  if not (line.startswith('aform(')) or not now:
    continue
  now = False or all_aforms
  [dim, aform] = line.split('aform(', 1)[1].split('):', 1)
  dim = int(dim)
  aform = aform.replace('--','');
  aform = aform.replace('(','');
  aform = aform.replace(')','');
  aform = aform.replace(',','');
  pdevs = [floatify(sd) for sd in aform.split()];
  sortidx = int(pdevs[sortdim] * 10000000)
  print str(sortidx) + ' ' + line.strip()