use "unsynchonized.sml"
use "lorenz_core.sml";

fun read_lorenzij () =
  let
    val p::w::ij = map (valOf o Int.fromString) (CommandLine.arguments());
    val [p, w] = map Lorenz.nat_of_integer [p,w];
    val [i, j] = map Lorenz.Int_of_integer ij;
    val _ = Lorenz.lorenz_irects p w i j
    val _ = print "= Finished with irects"
    val _ = print "= Trying to exit with success"
  in
    OS.Process.exit OS.Process.success
  end
  handle _ =>
    let
      val _ = print "\n= Exception.\n"
    in
      OS.Process.exit OS.Process.failure
    end
  ;

fun lorenzc () =
  let
    val [w, m, a, r, x, ex, y, ey, u, eu] = map (Lorenz.Int_of_integer o valOf o Int.fromString) (CommandLine.arguments())
    val _ = Lorenz.lorenzc w m a r x ex y ey u eu
  in
    ()
  end
  handle _ => print "\n= Exception.\n"
  ;

