#!/usr/bin/python
import re
import sys
import os
import math
import subprocess
import StringIO
import tempfile
import time

returning = False
if (len(sys.argv) < 2):
  print "give hg id as argument"
  sys.exit(-1)

hgid = sys.argv[1]
initials = "INITIALS"
if (len(sys.argv) == 3):
  initials = sys.argv[2]
filter_p = None
filter_w = None
if (len(sys.argv) == 4):
  filter_p = sys.argv[2]
  filter_w = sys.argv[3]
initialfile = hgid + "/" + initials

returned = tempfile.NamedTemporaryFile()
new = tempfile.NamedTemporaryFile()
failed = tempfile.NamedTemporaryFile()
running = tempfile.NamedTemporaryFile()

with open(initialfile, 'r') as infile:
  for line in infile:
    line = line.replace('~', '-')
    [p, w, i, j, k, info] = line.split()
    if not filter_p is None and not filter_w is None and not (p == filter_p and w == filter_w):
      continue
    p = int(p)
    i = int(i)
    j = int(j)
    d = 2.0**(-p)
    ds = str (d)
    dm = str (-d)
    i0 = str (i * d)
    j0 = str (j * d)
    i1 = str ((i + 1) * d)
    j1 = str ((j + 1) * d)
    if info == "RETURNED":
      c = "3"
      tf = returned
    elif info == "NEW" or info == "EXISTING":
      c = "2"
      tf = new
    elif info == "FAILED":
      c = "1"
      tf = failed
    else:
      c = "4"
      tf = running
    tf.write(" ".join([i0, j0, "0", ds, c, "\n"]))
    tf.write(" ".join([i0, j0, ds, "0", c, "\n"]))
    tf.write(" ".join([i1, j1, "0", dm, c, "\n"]))
    tf.write(" ".join([i1, j1, dm, "0", c, "\n"]))
    tf.write(" ".join([i0, j0, ds, ds, c, "\n"]))
    tf.write(" ".join([i0, j1, ds, dm, c, "\n"]))

returned.flush()
new.flush()
failed.flush()
running.flush()

subprocess.call(["gnuplot", "-persist", "-e",
  "filenames = \"" + " ".join([returned.name, new.name, failed.name, running.name]) + "\"; set terminal x11;\
  plot 'tucker.txt' using 1:3:($2 - $1):(0):(0) with vectors linecolor variable nohead notitle,\
    'tucker.txt' using 1:3:(0):($4 - $3):(0) with vectors linecolor variable nohead notitle,\
    'tucker.txt' using 2:4:($1 - $2):(0):(0) with vectors linecolor variable nohead notitle,\
    'tucker.txt' using 2:4:(0):($3 - $4):(0) with vectors linecolor variable nohead notitle,\
    'tucker.txt' using (-$1):(-$3):($1 - $2):(0):(0) with vectors linecolor variable nohead notitle, \
    'tucker.txt' using (-$1):(-$3):(0):($3 - $4):(0) with vectors linecolor variable nohead notitle, \
    'tucker.txt' using (-$2):(-$4):($2 - $1):(0):(0) with vectors linecolor variable nohead notitle, \
    'tucker.txt' using (-$2):(-$4):(0):($4 - $3):(0) with vectors linecolor variable nohead notitle, \
    for [file in filenames] file using 1:2:3:4:5 with vectors linecolor variable nohead notitle;\
  pause -1"])
print "CLOSING"
returned.close()
new.close()
failed.close()
running.close()

