#!/usr/bin/python
import re
import sys
import os
import fileinput
from decimal import Decimal, getcontext

def floatify (sd):
  return float(sd.replace('~','-'))

def add(xs, ys):
  assert len(xs) == len(ys)
  return [x + y for x, y in zip(xs, ys)]

def uminus(xs):
  return [-x for x in xs]

def segments (c, pdevs):
  if len(pdevs) == 0:
    return [(c, c)]
  else:
    p0 = pdevs[0]
    p1 = uminus(p0)
    segs = segments(c, pdevs[1:])
    return [s for (s0, s1) in segs for s in
      [(add(s0, p0), add(s1, p0)), (add(s0, p1), add(s1, p1)), (add(s0, p0), add(s0, p1)), (add(s1, p0), add(s1, p1))]]

def print_segment(seg):
  (x0, x1) = seg
  d = add(x1, uminus(x0))
  line = ''
  for x in x0:
    line = line + str(x) + ' '
  for x in d:
    line = line + str(x) + ' '
  print line

def reduce_pdevs(pdevs):
  thres = 0.000001
  pdevs = [pd for pd in pdevs if max(pd) >= thres]
  rs = [pd for pd in pdevs if max(pd) < thres]
  return pdevs

while 1:
  try:
    line = sys.stdin.readline()
  except KeyboardInterrupt:
    break
  if not line:
    break
  if not (line.startswith('aform(')) or line.strip() == '':
    continue
  [dim, aform] = line.split('aform(', 1)[1].split('):', 1)
  dim = int(dim)
  aform = aform.replace('--','');
  aform = aform.replace('(','');
  aform = aform.replace(')','');
  aform = aform.replace(',','');
  pdevs = [floatify(sd) for sd in aform.split()];
  pdevs = [pdevs[n:n+dim] for n in range(0, len(pdevs), dim)]
  c = pdevs[0]
  pdevs = pdevs[1:]
  for seg in segments (c, pdevs):
    print_segment(seg)

