#!/usr/bin/python
import re
import sys
import os
import tempfile
import subprocess
from decimal import Decimal, getcontext

if (len(sys.argv) < 6):
  print "Error: pass dimension, index of desired indices and inputfile as arguments!"
  sys.exit(-1)

dim = int(sys.argv[1])
pdim1 = int(sys.argv[2])
pdim2 = int(sys.argv[3])
pdim3 = int(sys.argv[4])
infilename = sys.argv[5]

print ("dimension: " + str(dim))
print ("plot dimension 1: " + str(pdim1))
print ("plot dimension 2: " + str(pdim2))
print ("plot dimension 3: " + str(pdim3))

dre = re.compile(r"[\d]+:|(~?[\d]+e\~?[\d]+)")
dre1 = re.compile(r"[a-z]+")

outfile = tempfile.NamedTemporaryFile()

def floatify (sd):
  return float(sd.replace('~','-'))

min1=1e100
max1=-1e100
min2=1e100
max2=-1e100
min3=1e100
max3=-1e100

with open (infilename, 'r') as infile:
  for line in infile:
    if line.startswith('='):
      continue
    if not (line.startswith('rect:')) or line.strip() == '':
      continue
    ds = dre.findall(line)
    l1 = ds[2+pdim1]
    l2 = ds[2+pdim2]
    l3 = ds[2+pdim3]
    u1 = ds[2+dim+pdim1]
    u2 = ds[2+dim+pdim2]
    u3 = ds[2+dim+pdim3]
    if l1 < min1:
      min1 = l1
    if l2 < min2:
      min2 = l2
    if l3 < min3:
      min3 = l3
    if u1 > max1:
      max1 = u1
    if u2 > max2:
      max2 = u2
    if u3 > max3:
      max3 = u3
    for d in [l1, l2, l3, u1, u2, u3]:
      outfile.write(str(floatify(d)) + ", ")
    outfile.write("\n")

outfile.flush()
outfile.close()

filename = outfile.name
print ("Enclosure: (" + str(min1) + ", " + str(min2) + ", " + str(min3) + ") - (" + str(max1) + ", " + str(max2) + ", " + str(max3) + ")")
subprocess.call(["gnuplot", "-persist", "-e",
  "set view equal xyz; set terminal x11; splot '" +
  filename + "' using 1:2:3:($4 - $1):(0):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:2:3:(0):($5 - $2):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:5:3:($4 - $1):(0):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 4:2:3:(0):($5 - $2):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:2:3:(0):(0):($6 - $3) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 4:2:3:(0):(0):($6 - $3) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:5:3:(0):(0):($6 - $3) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 4:5:3:(0):(0):($6 - $3) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:2:6:($4 - $1):(0):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:2:6:(0):($5 - $2):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 1:5:6:($4 - $1):(0):(0) with vectors linecolor 1 nohead notitle, '" +
    filename + "' using 4:2:6:(0):($5 - $2):(0) with vectors linecolor 1 nohead notitle;\
    pause -1"])

