#!/usr/bin/python
import re
import sys
import os
import subprocess
from decimal import Decimal, getcontext

if (len(sys.argv) < 5):
  print "Error: pass dimension, index of desired indices and inputfile as arguments!"
  sys.exit(-1)

dim = int(sys.argv[1])
pdim1 = int(sys.argv[2])
pdim2 = int(sys.argv[3])
infilename = sys.argv[4]

print ("dimension: " + str(dim))
print ("plot dimension 1: " + str(pdim1))
print ("plot dimension 2: " + str(pdim2))

dre = re.compile(r"[\d]+:|(~?[\d]+e\~?[\d]+)")
dre1 = re.compile(r"[a-z]+")

outfilename = "plot.csv"
outfile = open (outfilename, "w")

def floatify (sd):
  return float(sd.replace('~','-'))

min1=1e100
max1=-1e100
min2=1e100
max2=-1e100

with open (infilename, 'r') as infile:
  for line in infile:
    if line.startswith('='):
      continue
    if not (line.startswith('rect:')) or line.strip() == '':
      continue
    ds = dre.findall(line)
    l1 = ds[2+pdim1]
    l2 = ds[2+pdim2]
    u1 = ds[2+dim+pdim1]
    u2 = ds[2+dim+pdim2]
    if l1 < min1:
      min1 = l1
    if l2 < min2:
      min2 = l2
    if u1 > max1:
      max1 = u1
    if u2 > max2:
      max2 = u2
    for d in [l1, l2, u1, u2]:
      outfile.write(str(floatify(d)) + ", ")
    outfile.write("\n")

outfile.flush()
outfile.close()

print ("Enclosure: (" + str(min1) + ", " + str(min2) + ") - (" + str(max1) + ", " + str(max2) + ")")
subprocess.call(["gnuplot", "-persist", "-e",
  "filename=\"" + outfilename + "\";\
  set terminal x11;\
  set size ratio -1;\
  set style arrow 1 nohead;\
  set xlabel \"x\";\
  set ylabel \"z\";\
  set size ratio 1;\
  unset key;\
  plot \
    filename using 1:2:($3 - $1):(0) with vectors arrowstyle 1, \
    filename using 1:2:(0):($4 - $2) with vectors arrowstyle 1, \
    filename using 1:4:($3 - $1):(0) with vectors arrowstyle 1, \
    filename using 3:2:(0):($4 - $2) with vectors arrowstyle 1; pause -1"])
print "Closing"

