#!/usr/bin/python
import re
import sys
import os
from decimal import Decimal, getcontext

if (len(sys.argv) < 6):
  print "Error: pass i/d/a dim x y z"
  sys.exit(-1)

interpol = (sys.argv[1] == 'i')
all_aforms = (sys.argv[1] == 'a')
dim = int(sys.argv[2])
pdim1 = int(sys.argv[3])
pdim2 = int(sys.argv[4])
pdim3 = int(sys.argv[5])

def floatify (sd):
  return float(sd.replace('~','-'))

dre = re.compile(r"[\d]+:|(~?[\d]+e\~?[\d]+)")

now = False or all_aforms
while 1:
  try:
    line = sys.stdin.readline()
  except KeyboardInterrupt:
    break
  if not line:
    break
  if line.strip() == '':
    continue
  if (not all_aforms and (interpol and line.startswith('= interpolated step:')) or (not interpol and line.startswith('= discrete step:'))):
    now = True
    continue
  if not (line.startswith('rect:')) or not now:
    continue
  now = False or all_aforms

  ds = dre.findall(line)
  l1 = floatify(ds[2+pdim1]    )
  l2 = floatify(ds[2+pdim2]    )
  col= floatify(ds[2+pdim3]    )
  u1 = floatify(ds[2+dim+pdim1])
  u2 = floatify(ds[2+dim+pdim2])

  line = ''
  for d in [col, l1, l2, u1, u2, u1 - l1, u2 - l2]:
    line = line + (("%.3f" % d) + ", ")
  print line
