(* taken from "~~/src/Pure/ML-Systems/unsynchronized.ML*)
structure Unsynchronized =
struct

datatype ref = datatype ref;

val op := = op :=;
val ! = !;

fun change r f = r := f (! r);
fun change_result r f = let val (x, y) = f (! r) in r := y; x end;

fun inc i = (i := ! i + (1: int); ! i);
fun dec i = (i := ! i - (1: int); ! i);

end;

use "lorenz_core.ML";

fun lorenzc () =
  let
    val [w, m, a, r, x, ex, y, ey, u, eu] = map (Lorenz.Int_of_integer o valOf o Int.fromString) (CommandLine.arguments())
    val _ = Lorenz.lorenzc w m a r x ex y ey u eu
  in
    ()
  end
  handle _ => print "\n= Exception.\n"
  ;

