(* taken from "~~/src/Pure/ML-Systems/unsynchronized.ML*)
structure Unsynchronized =
struct

datatype ref = datatype ref;

val op := = op :=;
val ! = !;

fun change r f = r := f (! r);
fun change_result r f = let val (x, y) = f (! r) in r := y; x end;

fun inc i = (i := ! i + (1: int); ! i);
fun dec i = (i := ! i - (1: int); ! i);

end;

use "vanderpol_core.ML";

fun vanderpol () =
  let
    val [w, e, a, r, err] = map (Vanderpol.Int_of_integer o valOf o Int.fromString) (CommandLine.arguments());
    val _ = Vanderpol.vanderpol_limit w e a r err
  in
    ()
  end
  handle _ => print "\n= Exception.\n"
  ;

